<template>
  <v-card color="lighten-2">
    <v-card-title class="text-h5 red lighten-3">
      Création du mail de demande au DPO
    </v-card-title>
    <v-form
      ref="form"
      v-model="valid"
      lazy-validation
      class="px-3">
      <v-card-text>
        <v-autocomplete
          v-model="organisme"
          :items="items"
          :loading="isLoading"
          :search-input.sync="search"
          color="white"
          hide-no-data
          hide-selected
          item-text="name"
          item-value="name"
          label="Société"
          placeholder="Start typing to Search"
          prepend-icon="mdi-database-search"
          return-object
        ></v-autocomplete>
      </v-card-text>
      <v-divider></v-divider>

      <v-card-text>
        <v-select
          v-model="motif"
          :items="motifs"
          item-text="intitule"
          item-value="id"
          label="Demande d’accès aux données"
          persistent-hint
          return-object
          single-line
          prepend-icon="mdi-comment-question "
        ></v-select>
      </v-card-text>
      <v-card-text>
        <v-text-field
          v-if="organisme"
          v-model="organisme.email"
          label="Adresse E-mail du DPO"
          required
          readonly
          prepend-icon="mdi-email"
        ></v-text-field>
      </v-card-text>
      <v-container>
        <v-row>
          <v-col cols="12" md="4">
            <v-text-field
              v-model="consomateur.first_name"
              label="Votre prénom"
              :rules="nameRules"
              required
            ></v-text-field>
          </v-col>
          <v-col cols="12" md="4">
            <v-text-field
              v-model="consomateur.last_name"
              label="Votre nom"
              :rules="nameRules"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12" md="4">
            <v-text-field
              :rules="emailRules"
              v-model="consomateur.email_consomateur"
              label="Email utilisé sur le site de la société sélectionné"
              required
            ></v-text-field>
          </v-col>
        </v-row>
      </v-container>
      <v-container fluid>
        <v-text-field
          v-if="motif&&organisme"
          v-model="template.objet"
          label="Objet"
          required
          readonly
        ></v-text-field>
        <v-textarea counter label="Gabarit" v-if="motif&&organisme"
                    v-model="template.gabarit" readonly></v-textarea>
      </v-container>
      <v-container class="px-0" fluid>
        <v-checkbox
          v-model="accept"
          label="En cochant cette case, UFC Que Choisir fera un suivi de votre demande en vous relançant dans 1 mois pour en connaitre l’issue"
        ></v-checkbox>
      </v-container>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="grey ">
          Réinitialiser
          <v-icon right> mdi-close-circle</v-icon>
        </v-btn>
        <v-btn color="primary " @click="mailto">
          J’envoie l’email
          <v-icon right> mdi-send</v-icon>
        </v-btn>
        <v-btn color="secondary " @click="copy_email">
          Je copie le contenu
          <v-icon right> mdi-content-copy</v-icon>
        </v-btn>
        <v-btn color="success " @click="saveData(1)">
          Je m’envoie cet email
          <v-icon right> mdi-recycle</v-icon>
        </v-btn>
      </v-card-actions>
    </v-form>
    <v-snackbar
      v-model="snackbar"
      :timeout="timeout"
    >
      {{ text }}

      <template v-slot:action="{ attrs }">
        <v-btn
          color="blue"
          text
          v-bind="attrs"
          @click="snackbar = false"
        >
          X
        </v-btn>
      </template>
    </v-snackbar>
  </v-card>
</template>
<script>
let axios = require('axios');
const base_URL = "http://127.0.0.1:8000"
export default {

  data: () => ({
    emailRules: [
      v => !!v || 'E-mail is required',
      v => /.+@.+\..+/.test(v) || 'E-mail must be valid',
    ],
    nameRules: [
      v => !!v || 'Name is required',
      v => (v && v.length <= 20) || 'champs doit comprendre moins de 20 caractères',
    ],
    valid: false,
    descriptionLimit: 60,
    organismes: [],
    isLoading: false,
    organisme: {
      id: null,
      name: "",
      email: ""
    },
    search: null,
    snackbar: false,
    text: 'Mail bien copié dans le clipboard',
    timeout: 2000,
    motif: {
      id: 0,
      intitule: '',
      gabarit: ''
    },
    consomateur: {
      first_name: "",
      last_name: "",
      email_consomateur: "",
    },
    motifs: [],
    accept: false,
    template: {
      objet: "",
      gabarit: ""
    }
  }),

  computed: {
    fields() {
      if (!this.organisme) return []
      return Object.keys(this.organisme).map(key => {
        return {
          key,
          value: this.organisme[key] || 'n/a',
        }
      })
    },
    items() {
      return this.organismes.map(organisme => {
        const name = organisme.name.length > this.descriptionLimit
          ? organisme.name.slice(0, this.descriptionLimit) + '...'
          : organisme.name

        return Object.assign({}, organisme, {name})
      })
    },
    info() {
      return JSON.stringify(this.consomateur);
    }
  },
  beforeMount() {
    this.loadData();
    this.loadrelanceDemande();

  },
  watch: {
    async search(val) {
      // Items have already been loaded
      if (this.items.length > 0) return
      if (this.isLoading) return
      this.isLoading = true
      if (val && val != '' && val !== this.select) {
        this.searchOrganisme(val)
      }
    },
    motif(val) {
      console.log(val)
      this.fillEmail()
    },
    template(val) {
      console.log(val)
      this.fillEmail()
    },
    info(val) {
      console.log(val)
      this.fillEmail()
    }
  },
  methods: {
    fillEmail() {
      var mapObj = {
        nom_dpo: this.organisme ? this.organisme.name : "",
        motif: this.motif.intitule,
        first_name: this.consomateur.first_name,
        last_name: this.consomateur.last_name,
        email_consommateur: this.consomateur.email
      };
      this.template.gabarit = this.replaceAll(this.motif.gabarit, mapObj)
      this.template.objet = this.motif.intitule + ' :  < ' + this.organisme.name + ' >'
    },
    async loadData() {

      await this.loadMotif()
      await this.loadOrganisme()
    },
    async loadrelanceDemande() {
      var url = this.$route.path.split('/');
      console.log(url)
      if (url.includes("demandes")) {
        var token = url.pop();
        if (token) {
          var axios = require('axios');
          var config = {
            method: 'get',
            url: base_URL + '/demandes/' + token,
            headers: {}
          };
          axios(config)
            .then( (response) =>{
              var result = response.data
              this.organisme = result.organisme
              this.motif = result.motif
              this.template = result.template
              this.consomateur = {
                first_name: result.first_name,
                last_name: result.last_name,
                email_consomateur: result.email_consomateur,
              }
            })
            .catch(function (error) {
              console.log(error);
            });
        }
      }
    },
    async searchOrganisme(keyword) {
      var config = {
        method: 'get',
        url: base_URL + '/oganismes?limit=500000',
        headers: {}
      };
      await axios(config)
        .then((response) => {
          const {organismes} = response.data
          this.organismes = organismes
        })
        .catch(function (error) {
          console.log(error);
        }).finally(() => (this.isLoading = false));
    },
    async loadMotif() {
      var config = {
        method: 'get',
        url: base_URL + '/motifs',
        headers: {}
      };

      await axios(config)
        .then((response) => {
          this.motifs = response.data
        })
        .catch(function (error) {
          console.log(error);
        });
    },
    async loadOrganisme() {
      var config = {
        method: 'get',
        url: base_URL + '/oganismes?limit=500000',
        headers: {}
      };
      await axios(config)
        .then((response) => {
          const {organismes} = response.data
          this.organismes = organismes
        })
        .catch(function (error) {
          console.log(error);
        }).finally(() => (this.isLoading = false));
    },
    async saveData(action) {
      if (this.$refs.form.validate()) {
        var axios = require('axios');
        let data = {
          organisme: this.organisme.id,
          motif: this.motif.id,
          first_name: this.consomateur.first_name,
          last_name: this.consomateur.first_name,
          email_consomateur: this.consomateur.email,
          template: this.template,
          action: action
        }
        var config = {
          method: 'post',
          url: base_URL + '/demandes?accept=' + this.accept,
          headers: {
            'Content-Type': 'application/json'
          },
          data: data
        };

        axios(config)
          .then(function (response) {
            console.log(JSON.stringify(response.data));
          })
          .catch(function (error) {
            console.log(error);
          });
      }
    },
    mailto() {
      if (this.accept) {
        this.saveData(2)
      }
      window.location.href = (`mailto:${this.organisme.email}?subject=${this.template.objet}&body=${this.template.gabarit}`)
    },
    copy_email() {
      if (this.accept) {
        this.saveData(3)
      }
      this.copyTextToClipboard(JSON.stringify(this.template))
    },
    fallbackCopyTextToClipboard(text) {
      var textArea = document.createElement("textarea");
      textArea.value = text;

      // Avoid scrolling to bottom
      textArea.style.top = "0";
      textArea.style.left = "0";
      textArea.style.position = "fixed";

      document.body.appendChild(textArea);
      textArea.focus();
      textArea.select();

      try {
        var successful = document.execCommand('copy');
        var msg = successful ? 'successful' : 'unsuccessful';
        console.log('Fallback: Copying text command was ' + msg);
      } catch (err) {
        console.error('Fallback: Oops, unable to copy', err);
      }

      document.body.removeChild(textArea);
    },
    copyTextToClipboard(text) {
      if (!navigator.clipboard) {
        this.fallbackCopyTextToClipboard(text);
        return;
      }
      navigator.clipboard.writeText(text).then(function () {
        console.log('Async: Copying to clipboard was successful!');
      }, function (err) {
        console.error('Async: Could not copy text: ', err);
      });
      this.snackbar = true
    },
    replaceAll(str, mapObj) {
      var re = new RegExp(Object.keys(mapObj).join("|"), "gi");
      return str.replace(re, function (matched) {
        return mapObj[matched.toLowerCase()];
      });
    },
  }
}
</script>
